Treemap with Drilldown in JavaScript

Using ApexCharts with JavaScript

This Treemap with Drilldown example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Per-level colour palettes. Treemap uses distributed colouring (one colour per
// tile), so a level's palette tints that level's tiles and signals which branch
// you are inside. Drilling back restores the parent palette.
var sectorColors = ['#1565C0', '#2E7D32', '#C62828', '#EF6C00', '#6A1B9A']
var bluePalette = ['#0D47A1', '#1976D2', '#42A5F5', '#90CAF9'] // Technology
var cyanPalette = ['#006064', '#00838F', '#00ACC1', '#4DD0E1'] // Tech > Cloud
var greenPalette = ['#1B5E20', '#388E3C', '#66BB6A'] // Financials
var redPalette = ['#B71C1C', '#E53935', '#EF9A9A'] // Healthcare
var amberPalette = ['#E65100', '#FB8C00', '#FFB74D'] // Energy
var purplePalette = ['#4A148C', '#8E24AA', '#CE93D8'] // Consumer

// Distributed colouring shared by every level.
var distributed = { treemap: { distributed: true, enableShades: false } }

var options = {
  series: [
    {
      data: [
        { x: 'Technology', y: 620, drilldown: 'tech' },
        { x: 'Financials', y: 430, drilldown: 'fin' },
        { x: 'Healthcare', y: 380, drilldown: 'health' },
        { x: 'Energy', y: 290, drilldown: 'energy' },
        { x: 'Consumer', y: 340, drilldown: 'consumer' },
      ],
    },
  ],
  chart: {
    type: 'treemap',
    height: 450,
    toolbar: {
      show: false,
    },
  },
  legend: {
    show: false,
  },
  colors: sectorColors,
  plotOptions: distributed,
  dataLabels: {
    enabled: true,
    style: {
      fontSize: '14px',
    },
  },
  title: {
    text: 'Market Capitalisation by Sector',
    align: 'left',
  },
  subtitle: {
    text: 'Click a sector to drill into its industries, then into companies. Use the breadcrumb to go back.',
    align: 'left',
  },
  drilldown: {
    enabled: true,
    breadcrumb: {
      show: true,
      position: 'top-right',
      rootLabel: 'All Sectors',
      separator: ' / ',
    },
    series: [
      {
        id: 'tech',
        name: 'Technology',
        colors: bluePalette,
        plotOptions: distributed,
        data: [
          { x: 'Cloud', y: 260, drilldown: 'tech-cloud' },
          { x: 'Devices', y: 190 },
          { x: 'Software', y: 120 },
          { x: 'Semiconductors', y: 50 },
        ],
      },
      {
        id: 'tech-cloud',
        name: 'Cloud',
        colors: cyanPalette,
        plotOptions: distributed,
        data: [
          { x: 'Compute', y: 110 },
          { x: 'Storage', y: 80 },
          { x: 'Networking', y: 45 },
          { x: 'Analytics', y: 25 },
        ],
      },
      {
        id: 'fin',
        name: 'Financials',
        colors: greenPalette,
        plotOptions: distributed,
        data: [
          { x: 'Banking', y: 210 },
          { x: 'Insurance', y: 140 },
          { x: 'Payments', y: 80 },
        ],
      },
      {
        id: 'health',
        name: 'Healthcare',
        colors: redPalette,
        plotOptions: distributed,
        data: [
          { x: 'Pharma', y: 200 },
          { x: 'Devices', y: 110 },
          { x: 'Services', y: 70 },
        ],
      },
      {
        id: 'energy',
        name: 'Energy',
        colors: amberPalette,
        plotOptions: distributed,
        data: [
          { x: 'Renewables', y: 160 },
          { x: 'Oil & Gas', y: 90 },
          { x: 'Utilities', y: 40 },
        ],
      },
      {
        id: 'consumer',
        name: 'Consumer',
        colors: purplePalette,
        plotOptions: distributed,
        data: [
          { x: 'Retail', y: 180 },
          { x: 'Food & Beverage', y: 100 },
          { x: 'Apparel', y: 60 },
        ],
      },
    ],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Treemap with Drilldown in Vue

Using ApexCharts with Vue

This Treemap with Drilldown example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="treemap"
        height="450"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Per-level colour palettes. Treemap uses distributed colouring (one colour per
// tile), so a level's palette tints that level's tiles and signals which branch
// you are inside. Drilling back restores the parent palette.
var sectorColors = ['#1565C0', '#2E7D32', '#C62828', '#EF6C00', '#6A1B9A']
var bluePalette = ['#0D47A1', '#1976D2', '#42A5F5', '#90CAF9'] // Technology
var cyanPalette = ['#006064', '#00838F', '#00ACC1', '#4DD0E1'] // Tech > Cloud
var greenPalette = ['#1B5E20', '#388E3C', '#66BB6A'] // Financials
var redPalette = ['#B71C1C', '#E53935', '#EF9A9A'] // Healthcare
var amberPalette = ['#E65100', '#FB8C00', '#FFB74D'] // Energy
var purplePalette = ['#4A148C', '#8E24AA', '#CE93D8'] // Consumer

// Distributed colouring shared by every level.
var distributed = { treemap: { distributed: true, enableShades: false } }

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            { x: 'Technology', y: 620, drilldown: 'tech' },
            { x: 'Financials', y: 430, drilldown: 'fin' },
            { x: 'Healthcare', y: 380, drilldown: 'health' },
            { x: 'Energy', y: 290, drilldown: 'energy' },
            { x: 'Consumer', y: 340, drilldown: 'consumer' },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'treemap',
          height: 450,
          toolbar: {
            show: false,
          },
        },
        legend: {
          show: false,
        },
        colors: sectorColors,
        plotOptions: distributed,
        dataLabels: {
          enabled: true,
          style: {
            fontSize: '14px',
          },
        },
        title: {
          text: 'Market Capitalisation by Sector',
          align: 'left',
        },
        subtitle: {
          text: 'Click a sector to drill into its industries, then into companies. Use the breadcrumb to go back.',
          align: 'left',
        },
        drilldown: {
          enabled: true,
          breadcrumb: {
            show: true,
            position: 'top-right',
            rootLabel: 'All Sectors',
            separator: ' / ',
          },
          series: [
            {
              id: 'tech',
              name: 'Technology',
              colors: bluePalette,
              plotOptions: distributed,
              data: [
                { x: 'Cloud', y: 260, drilldown: 'tech-cloud' },
                { x: 'Devices', y: 190 },
                { x: 'Software', y: 120 },
                { x: 'Semiconductors', y: 50 },
              ],
            },
            {
              id: 'tech-cloud',
              name: 'Cloud',
              colors: cyanPalette,
              plotOptions: distributed,
              data: [
                { x: 'Compute', y: 110 },
                { x: 'Storage', y: 80 },
                { x: 'Networking', y: 45 },
                { x: 'Analytics', y: 25 },
              ],
            },
            {
              id: 'fin',
              name: 'Financials',
              colors: greenPalette,
              plotOptions: distributed,
              data: [
                { x: 'Banking', y: 210 },
                { x: 'Insurance', y: 140 },
                { x: 'Payments', y: 80 },
              ],
            },
            {
              id: 'health',
              name: 'Healthcare',
              colors: redPalette,
              plotOptions: distributed,
              data: [
                { x: 'Pharma', y: 200 },
                { x: 'Devices', y: 110 },
                { x: 'Services', y: 70 },
              ],
            },
            {
              id: 'energy',
              name: 'Energy',
              colors: amberPalette,
              plotOptions: distributed,
              data: [
                { x: 'Renewables', y: 160 },
                { x: 'Oil & Gas', y: 90 },
                { x: 'Utilities', y: 40 },
              ],
            },
            {
              id: 'consumer',
              name: 'Consumer',
              colors: purplePalette,
              plotOptions: distributed,
              data: [
                { x: 'Retail', y: 180 },
                { x: 'Food & Beverage', y: 100 },
                { x: 'Apparel', y: 60 },
              ],
            },
          ],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Treemap with Drilldown in React

Using ApexCharts with React

This Treemap with Drilldown example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Per-level colour palettes. Treemap uses distributed colouring (one colour per
// tile), so a level's palette tints that level's tiles and signals which branch
// you are inside. Drilling back restores the parent palette.
var sectorColors = ['#1565C0', '#2E7D32', '#C62828', '#EF6C00', '#6A1B9A']
var bluePalette = ['#0D47A1', '#1976D2', '#42A5F5', '#90CAF9'] // Technology
var cyanPalette = ['#006064', '#00838F', '#00ACC1', '#4DD0E1'] // Tech > Cloud
var greenPalette = ['#1B5E20', '#388E3C', '#66BB6A'] // Financials
var redPalette = ['#B71C1C', '#E53935', '#EF9A9A'] // Healthcare
var amberPalette = ['#E65100', '#FB8C00', '#FFB74D'] // Energy
var purplePalette = ['#4A148C', '#8E24AA', '#CE93D8'] // Consumer

// Distributed colouring shared by every level.
var distributed = { treemap: { distributed: true, enableShades: false } }

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          { x: 'Technology', y: 620, drilldown: 'tech' },
          { x: 'Financials', y: 430, drilldown: 'fin' },
          { x: 'Healthcare', y: 380, drilldown: 'health' },
          { x: 'Energy', y: 290, drilldown: 'energy' },
          { x: 'Consumer', y: 340, drilldown: 'consumer' },
        ],
      },
    ],
    options: {
      chart: {
        type: 'treemap',
        height: 450,
        toolbar: {
          show: false,
        },
      },
      legend: {
        show: false,
      },
      colors: sectorColors,
      plotOptions: distributed,
      dataLabels: {
        enabled: true,
        style: {
          fontSize: '14px',
        },
      },
      title: {
        text: 'Market Capitalisation by Sector',
        align: 'left',
      },
      subtitle: {
        text: 'Click a sector to drill into its industries, then into companies. Use the breadcrumb to go back.',
        align: 'left',
      },
      drilldown: {
        enabled: true,
        breadcrumb: {
          show: true,
          position: 'top-right',
          rootLabel: 'All Sectors',
          separator: ' / ',
        },
        series: [
          {
            id: 'tech',
            name: 'Technology',
            colors: bluePalette,
            plotOptions: distributed,
            data: [
              { x: 'Cloud', y: 260, drilldown: 'tech-cloud' },
              { x: 'Devices', y: 190 },
              { x: 'Software', y: 120 },
              { x: 'Semiconductors', y: 50 },
            ],
          },
          {
            id: 'tech-cloud',
            name: 'Cloud',
            colors: cyanPalette,
            plotOptions: distributed,
            data: [
              { x: 'Compute', y: 110 },
              { x: 'Storage', y: 80 },
              { x: 'Networking', y: 45 },
              { x: 'Analytics', y: 25 },
            ],
          },
          {
            id: 'fin',
            name: 'Financials',
            colors: greenPalette,
            plotOptions: distributed,
            data: [
              { x: 'Banking', y: 210 },
              { x: 'Insurance', y: 140 },
              { x: 'Payments', y: 80 },
            ],
          },
          {
            id: 'health',
            name: 'Healthcare',
            colors: redPalette,
            plotOptions: distributed,
            data: [
              { x: 'Pharma', y: 200 },
              { x: 'Devices', y: 110 },
              { x: 'Services', y: 70 },
            ],
          },
          {
            id: 'energy',
            name: 'Energy',
            colors: amberPalette,
            plotOptions: distributed,
            data: [
              { x: 'Renewables', y: 160 },
              { x: 'Oil & Gas', y: 90 },
              { x: 'Utilities', y: 40 },
            ],
          },
          {
            id: 'consumer',
            name: 'Consumer',
            colors: purplePalette,
            plotOptions: distributed,
            data: [
              { x: 'Retail', y: 180 },
              { x: 'Food & Beverage', y: 100 },
              { x: 'Apparel', y: 60 },
            ],
          },
        ],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="treemap"
          height={450}
        />
      </div>
    </div>
  )
}

export default ApexChart

Treemap with Drilldown in Angular

Using ApexCharts with Angular

This Treemap with Drilldown example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private sectorColors: any = ['#1565C0', '#2E7D32', '#C62828', '#EF6C00', '#6A1B9A'];

  private bluePalette: any = ['#0D47A1', '#1976D2', '#42A5F5', '#90CAF9'];

  private cyanPalette: any = ['#006064', '#00838F', '#00ACC1', '#4DD0E1'];

  private greenPalette: any = ['#1B5E20', '#388E3C', '#66BB6A'];

  private redPalette: any = ['#B71C1C', '#E53935', '#EF9A9A'];

  private amberPalette: any = ['#E65100', '#FB8C00', '#FFB74D'];

  private purplePalette: any = ['#4A148C', '#8E24AA', '#CE93D8'];

  private distributed: any = { treemap: { distributed: true, enableShades: false } };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                { x: 'Technology', y: 620, drilldown: 'tech' },
                { x: 'Financials', y: 430, drilldown: 'fin' },
                { x: 'Healthcare', y: 380, drilldown: 'health' },
                { x: 'Energy', y: 290, drilldown: 'energy' },
                { x: 'Consumer', y: 340, drilldown: 'consumer' },
              ],
            },
          ],
          chart: {
            type: 'treemap',
            height: 450,
            toolbar: {
              show: false,
            },
          },
          legend: {
            show: false,
          },
          colors: this.sectorColors,
          plotOptions: this.distributed,
          dataLabels: {
            enabled: true,
            style: {
              fontSize: '14px',
            },
          },
          title: {
            text: 'Market Capitalisation by Sector',
            align: 'left',
          },
          subtitle: {
            text: 'Click a sector to drill into its industries, then into companies. Use the breadcrumb to go back.',
            align: 'left',
          },
          drilldown: {
            enabled: true,
            breadcrumb: {
              show: true,
              position: 'top-right',
              rootLabel: 'All Sectors',
              separator: ' / ',
            },
            series: [
              {
                id: 'tech',
                name: 'Technology',
                colors: this.bluePalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Cloud', y: 260, drilldown: 'tech-cloud' },
                  { x: 'Devices', y: 190 },
                  { x: 'Software', y: 120 },
                  { x: 'Semiconductors', y: 50 },
                ],
              },
              {
                id: 'tech-cloud',
                name: 'Cloud',
                colors: this.cyanPalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Compute', y: 110 },
                  { x: 'Storage', y: 80 },
                  { x: 'Networking', y: 45 },
                  { x: 'Analytics', y: 25 },
                ],
              },
              {
                id: 'fin',
                name: 'Financials',
                colors: this.greenPalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Banking', y: 210 },
                  { x: 'Insurance', y: 140 },
                  { x: 'Payments', y: 80 },
                ],
              },
              {
                id: 'health',
                name: 'Healthcare',
                colors: this.redPalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Pharma', y: 200 },
                  { x: 'Devices', y: 110 },
                  { x: 'Services', y: 70 },
                ],
              },
              {
                id: 'energy',
                name: 'Energy',
                colors: this.amberPalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Renewables', y: 160 },
                  { x: 'Oil & Gas', y: 90 },
                  { x: 'Utilities', y: 40 },
                ],
              },
              {
                id: 'consumer',
                name: 'Consumer',
                colors: this.purplePalette,
                plotOptions: this.distributed,
                data: [
                  { x: 'Retail', y: 180 },
                  { x: 'Food & Beverage', y: 100 },
                  { x: 'Apparel', y: 60 },
                ],
              },
            ],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}